#include "trempoll.h"

int connectsock(char *host, char *service, char *protocol)
{
    int type = 0;
    int sock = 0;
    struct hostent *phe = NULL;
    struct protoent *ppe = NULL;
    struct servent *pse = NULL;
    struct sockaddr_in sin;

    bzero( (char*)&sin, sizeof(sin));
    sin.sin_family = AF_INET;
    if( (pse = getservbyname(service, protocol)) != NULL )
		sin.sin_port = pse->s_port;
    else if( (sin.sin_port = htons((uint32_t)atoi(service)) ) == 0 ) {
		fprintf(stderr, "Unknown service: %s\n", service);
		return -1;
    }
    if( (phe = gethostbyname(host)) != NULL)
		bcopy(phe->h_addr, (char *)&sin.sin_addr, phe->h_length);
    else if( (sin.sin_addr.s_addr = inet_addr(host)) == INADDR_NONE) {
		fprintf(stderr, "Unknown host: %s\n", host);
		return -1;
    }
    if( (ppe = getprotobyname(protocol)) == NULL) {
		fprintf(stderr, "Unknown port number: %s\n", protocol);
		return -1;
    }
    if( strcmp(protocol, "udp") == 0 )
		type = SOCK_DGRAM;
	else
		type = SOCK_STREAM;
    if( (sock = socket(PF_INET, type, ppe->p_proto)) < 0 ) {
		fprintf(stderr, "Unknown protocol: %s\n", protocol);
		return -1;
    }
    if( connect(sock, (struct sockaddr *)&sin, sizeof(sin)) < 0 ) {
		fprintf(stderr, "Cannot establish connection to %s:%s: %s\n", host, service, strerror(errno));
		return -1;
    }
    return sock;
}
