#include "trempoll.h"

int trempoll(struct trempollresult* serverinfo)
{
	char buf[TREMPOLL_INPUTSIZE];
    char* temp = NULL;
    int i = 0;
    int m = 0;
    int n = 0;
    int sock = 0;
    struct timeval start,end;
	fd_set set;




	if((sock = connectsock(serverinfo->address, "30720", "udp")) < 0)
		return 0;

    memset(buf, 0, TREMPOLL_INPUTSIZE);

	FD_ZERO (&set);
	FD_SET (sock, &set);
	
    i = write(sock, "\xFF\xFF\xFF\xFFgetstatus", 25);
	
    n = gettimeofday(&start, NULL);
	if ( select(FD_SETSIZE,&set,NULL,NULL, &(serverinfo->timeout)) == 0) {
		fprintf(stdout, "Timeout\n");
		return 1;
	}
	n = gettimeofday(&end, NULL);
	
	i = read(sock, buf, TREMPOLL_INPUTSIZE);
	
	if(shutdown(sock, SHUT_RDWR) < 0) {
		return 2;
    }
	
    if(i <= 0)
		return 3;
	
	if((n = bruteforce(buf, "statusResponse\n")) > 0) {
		buf[n] = ':';
	}

	serverinfo->responsetime.tv_sec  = end.tv_sec  - start.tv_sec;
	serverinfo->responsetime.tv_usec = end.tv_usec - start.tv_usec;

    temp = malloc(TREMPOLL_OUTPUTSIZE);
    if(!getvar(buf, temp, "sv_hostname")) {
		memcpy(serverinfo->sv_hostname, temp, 63);
		serverinfo->sv_hostname[63]='\0';
    } else {
		memcpy(serverinfo->sv_hostname, "N/A", 4);
	}

    if(!getvar(buf, temp, "mapname")) {
		memcpy(serverinfo->mapname, temp, 63);
		serverinfo->mapname[63]='\0';
	} else {
		memcpy(serverinfo->mapname, "N/A", 4);
	}

    if(!getvar(buf, temp, "version")) {
		memcpy(serverinfo->version, temp, 127);
		serverinfo->version[127]='\0';
	} else {
		memcpy(serverinfo->version, "N/A", 4);
	}

    if(!getvar(buf, temp, "gamename")) {
		memcpy(serverinfo->gamename, temp, 63);
		serverinfo->gamename[63]='\0';
	} else {
		memcpy(serverinfo->gamename, "N/A", 4);
	}

    if(!getvar(buf, temp, "g_markDeconstruct")) serverinfo->g_markDeconstruct	= atoi(temp); else serverinfo->g_markDeconstruct	= -1;
    if(!getvar(buf, temp, "sv_allowDownload"))	serverinfo->sv_allowDownload	= atoi(temp); else serverinfo->sv_allowDownload		= -1;
	if(!getvar(buf, temp, "g_needpass"))		serverinfo->g_needpass			= atoi(temp); else serverinfo->g_needpass			= -1;
    if(!getvar(buf, temp, "protocol"))			serverinfo->protocol			= atoi(temp); else serverinfo->protocol				= -1;
    if(!getvar(buf, temp, "g_maxGameClients"))	serverinfo->g_maxGameClients	= atoi(temp); else serverinfo->g_maxGameClients		= -1;
    if(!getvar(buf, temp, "g_suddenDeathMode")) serverinfo->g_suddenDeathMode	= atoi(temp); else serverinfo->g_suddenDeathMode	= -1;
    if(!getvar(buf, temp, "sv_minPing"))		serverinfo->sv_minPing			= atoi(temp); else serverinfo->sv_minPing			= -1;
    if(!getvar(buf, temp, "sv_maxPing"))		serverinfo->sv_maxPing			= atoi(temp); else serverinfo->sv_maxPing			= -1;
    if(!getvar(buf, temp, "sv_minRate"))		serverinfo->sv_minRate			= atoi(temp); else serverinfo->sv_minRate			= -1;
    if(!getvar(buf, temp, "sv_maxRate"))		serverinfo->sv_maxRate			= atoi(temp); else serverinfo->sv_maxRate			= -1;
    if(!getvar(buf, temp, "timelimit"))			serverinfo->timelimit			= atoi(temp); else serverinfo->timelimit			= -1;
    if(!getvar(buf, temp, "g_suddenDeathTime")) serverinfo->g_suddenDeathTime	= atoi(temp); else serverinfo->g_suddenDeathTime	= -1;
    if(!getvar(buf, temp, "sv_maxclients"))		serverinfo->sv_maxclients		= atoi(temp); else serverinfo->sv_maxclients		= -1;
    if(!getvar(buf, temp, "sv_privateClients")) serverinfo->sv_privateClients	= atoi(temp); else serverinfo->sv_privateClients	= -1;
    if(!getvar(buf, temp, "g_hiddenClients"))   serverinfo->g_hiddenClients		= atoi(temp); else serverinfo->g_hiddenClients		= -1;

	if(!getvar(buf, temp, "\\P")) {
		for (m=0; m<strlen(buf); m++)
			if ( buf[m] == '\n' )
				break;
		m=m+1;

		serverinfo->players.all=0;
		serverinfo->players.aliens=0;
		serverinfo->players.humans=0;
		serverinfo->players.specs=0;
		for (i=0; i<strlen(temp); i++) {
			if ( temp[i] != '-' ) {
				serverinfo->player[serverinfo->players.all].slot = i;
				
				switch (temp[i]) {
				case '0':
					serverinfo->player[serverinfo->players.all].team='S';
					serverinfo->players.specs++;
					break;
				case '1':
					serverinfo->player[serverinfo->players.all].team='A';
					serverinfo->players.aliens++;
					break;
				case '2':
					serverinfo->player[serverinfo->players.all].team='H';
					serverinfo->players.humans++;
					break;
				default:
					serverinfo->player[serverinfo->players.all].team='?';
					break;
				}

				for (n=m; n<strlen(buf); n++) {
					if ( buf[n] == '\n' )
						break;
				}
				
				serverinfo->player[serverinfo->players.all].frags = atoi(&buf[m]);
				
				for ( m++; m<n; m++)
					if ( buf[m] == ' ' )
						break;
				
				
				serverinfo->player[serverinfo->players.all].ping = atoi(&buf[m+1]);
				
				for ( m++; m<n; m++)
					if ( buf[m] == ' ' )
						break;
					
				if ( n-m-3 < 32) {
					memcpy(serverinfo->player[serverinfo->players.all].name,&buf[m+2],n-m-3);
					serverinfo->player[serverinfo->players.all].name[n-m-3]='\0';
				} else {
					memcpy(serverinfo->player[serverinfo->players.all].name,&buf[m+2],32);
					serverinfo->player[serverinfo->players.all].name[31]='\0';
				}
				serverinfo->players.all++;
				m=n+1;
			}
		}
	}

    free(temp);
    return 0;
}
