#include <errno.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>

#ifdef WIN32
    #include <windows.h>
    #include <winsock.h>
#else
    #include <arpa/inet.h>
    #include <netinet/in.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <sys/time.h>
#endif

#define TREMPOLL_INPUTSIZE 10000
#define TREMPOLL_OUTPUTSIZE 100



struct singleplayerinfo {
	short slot;
	char team;
	short frags;
	short ping;
	char name[32];
};

struct trem_players {
	short all;
	short aliens;
	short humans;
	short specs;
};

struct trempollresult {
	char address[64];
	short port;
	struct timeval timeout;
	
	char sv_hostname[64];
	char mapname[64];
	char version[128];
	char gamename[64];

	struct trem_players players;
	// needs a better solution!
	struct singleplayerinfo player[64];

	char g_markDeconstruct:2;
	char sv_allowDownload:2;
	char g_needpass:2;

	char protocol;
	char g_maxGameClients;
	char g_suddenDeathMode;
	char sv_privateClients;
	char g_hiddenClients;

	short timelimit;
	short g_unlagged;
	short g_suddenDeathTime;
	short sv_maxPing;
	short sv_minPing;
	short sv_maxclients;
	
	int sv_maxRate;
	int sv_minRate;

	struct timeval responsetime;
};

int trempoll(struct trempollresult* serverinfo);

int connectsock(char*, char*, char*);
int bruteforce(char*, char*);
short int getvar(char*, char*, char*);
