#include <stdio.h>

#include "libtrempoll-src/trempoll.h"


const char *trempoll_errors[] = { 
/*1*/	"Timeout",
/*2*/	"Error closing connection",
/*3*/	"Failed to connect",
/*4*/	"4"
		};

int main (int argc, const char * argv[]) {
	int result,i;
	struct trempollresult myServer;
	
	//snprintf(myServer.address, 64,"85.214.67.75");
	snprintf(myServer.address, 64,"88.198.132.37");
	myServer.port=30720;
	myServer.timeout.tv_sec =5;
	myServer.timeout.tv_usec=0;
	
	if ( (result = trempoll(&myServer)) != 0 ) {
		if ( result > 0 ) {
			fprintf(stderr,"%s\n",trempoll_errors[result]);
			return EXIT_FAILURE;
		} else {
			fprintf(stderr,"Unknown trempoll error\n");
			return EXIT_FAILURE;
		}
	}
			printf("Server --------------- %s:%i\n",myServer.address,myServer.port);
	printf("\tResponse Time ------ %g ms\n\n", (double)(myServer.responsetime.tv_usec)/1000. + (double)(myServer.responsetime.tv_sec)*1000.);
	printf("\tVersion ------------ %s\n",myServer.version);
	printf("\tProtocol ----------- %i\n",myServer.protocol);
	printf("\tgamename ----------- %s\n",myServer.gamename);
	printf("\tsv_minPing --------- %i\n",myServer.sv_minPing);
	printf("\tsv_maxPing --------- %i\n",myServer.sv_maxPing);
	printf("\tsv_minRate --------- %i\n",myServer.sv_minRate);
	printf("\tsv_maxRate --------- %i\n",myServer.sv_maxRate);
	printf("\tsv_allowDownload --- %i\n",myServer.sv_allowDownload);
	printf("\tMax. Rate ---------- %i\n\n",myServer.g_needpass);
	
	printf("Map ------------------- %s\n",myServer.mapname);
	printf("\tTimelimit ---------- %i\n",myServer.timelimit);
	printf("\tg_suddenDeathTime -- %i\n",myServer.g_suddenDeathTime);
	printf("\tg_suddenDeathMode -- %i\n\n",myServer.g_suddenDeathMode);
	
	printf("Players ---------------- [%i/%i+(%i+%i)]\n",
		myServer.players.all,
		myServer.sv_maxclients - myServer.sv_privateClients,
		myServer.g_hiddenClients,
		myServer.sv_privateClients
		);
	printf("\tAlien Players ------- %i\n",myServer.players.aliens);
	printf("\tHuman Players ------- %i\n",myServer.players.humans);
	printf("\tSpectators ---------- %i\n",myServer.players.specs);
	printf("\tFree Slots ---------- %i\n\n",myServer.sv_maxclients - myServer.sv_privateClients - myServer.players.all);
		
	printf("Slot\tFrags\tPing\tTeam\tName\n");
	
	for (i=0; i<myServer.players.all; i++) {
		printf(" %i\t %i\t %i\t %c \t%s\n",
			   myServer.player[i].slot,
			   myServer.player[i].frags,
			   myServer.player[i].ping,
			   myServer.player[i].team,
			   myServer.player[i].name
			   );
	}
	
	
	
	return 0;
}
